package com.hgzx.plp.ds.oc.model;

import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.enums.IdType;

import java.util.Date;
import java.io.Serializable;

/**
 * <p>
 * 设备数据
 * </p>
 *
 * @author 石蕴杰
 * @since 2018-11-14
 */
public class DeviceData implements Serializable {

    private static final long serialVersionUID = 1L;


    /**
     * 主键
     */
    @TableId(type = IdType.UUID)
    private String id;
    /**
     * 设备SN码
     */
    private String deviceSn;
    /**
     * 硬件版本
     */
    private String firmwareVer;
    /**
     * 基站id
     */
    private String baseStationId;
    /**
     * 信号强度
     */
    private String csq;
    /**
     * 物理小区标志
     */
    private String pci;
    /**
     * 模组识别号
     */
    private String iemi;
    /**
     * SIM卡号
     */
    private String imsi;
    /**
     * 设备状态 1=安装，0=拆卸
     */
    private String deviceStatus;
    /**
     * 电池剩余电量
     */
    private String deviceBatteryLevel;
    /**
     * 定位状态 1=定位成功，0=定位失败
     */
    private String positionStatus;
    /**
     * GPS纬度
     */
    private String gpsLatitude;
    /**
     * GPS经度
     */
    private String gpsLongitude;
    /**
     * 当前GPS时间
     */
    private String gpsTime;
    /**
     * GPS速度
     */
    private String gpsSpeed;
    /**
     * GPS方向角
     */
    private String gpsAngle;
    /**
     * GPS海拔高度
     */
    private String gpsAltitude;
    /**
     * 消息Id
     */
    private String messageId;
    /**
     * 保留字段
     */
    private String reserve;
    /**
     * 数据时间
     */
    private Date dataTime;
    /**
     * 唤醒时间
     */
    private Date awakenInterval;
    /**
     * 数据接收时间
     */
    private Date dataRevTime;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getDeviceSn() {
        return deviceSn;
    }

    public void setDeviceSn(String deviceSn) {
        this.deviceSn = deviceSn;
    }

    public String getFirmwareVer() {
        return firmwareVer;
    }

    public void setFirmwareVer(String firmwareVer) {
        this.firmwareVer = firmwareVer;
    }

    public String getBaseStationId() {
        return baseStationId;
    }

    public void setBaseStationId(String baseStationId) {
        this.baseStationId = baseStationId;
    }

    public String getCsq() {
        return csq;
    }

    public void setCsq(String csq) {
        this.csq = csq;
    }

    public String getPci() {
        return pci;
    }

    public void setPci(String pci) {
        this.pci = pci;
    }

    public String getIemi() {
        return iemi;
    }

    public void setIemi(String iemi) {
        this.iemi = iemi;
    }

    public String getImsi() {
        return imsi;
    }

    public void setImsi(String imsi) {
        this.imsi = imsi;
    }

    public String getDeviceStatus() {
        return deviceStatus;
    }

    public void setDeviceStatus(String deviceStatus) {
        this.deviceStatus = deviceStatus;
    }

    public String getDeviceBatteryLevel() {
        return deviceBatteryLevel;
    }

    public void setDeviceBatteryLevel(String deviceBatteryLevel) {
        this.deviceBatteryLevel = deviceBatteryLevel;
    }

    public String getPositionStatus() {
        return positionStatus;
    }

    public void setPositionStatus(String positionStatus) {
        this.positionStatus = positionStatus;
    }

    public String getGpsLatitude() {
        return gpsLatitude;
    }

    public void setGpsLatitude(String gpsLatitude) {
        this.gpsLatitude = gpsLatitude;
    }

    public String getGpsLongitude() {
        return gpsLongitude;
    }

    public void setGpsLongitude(String gpsLongitude) {
        this.gpsLongitude = gpsLongitude;
    }

    public String getGpsTime() {
        return gpsTime;
    }

    public void setGpsTime(String gpsTime) {
        this.gpsTime = gpsTime;
    }

    public String getGpsSpeed() {
        return gpsSpeed;
    }

    public void setGpsSpeed(String gpsSpeed) {
        this.gpsSpeed = gpsSpeed;
    }

    public String getGpsAngle() {
        return gpsAngle;
    }

    public void setGpsAngle(String gpsAngle) {
        this.gpsAngle = gpsAngle;
    }

    public String getGpsAltitude() {
        return gpsAltitude;
    }

    public void setGpsAltitude(String gpsAltitude) {
        this.gpsAltitude = gpsAltitude;
    }

    public String getMessageId() {
        return messageId;
    }

    public void setMessageId(String messageId) {
        this.messageId = messageId;
    }

    public String getReserve() {
        return reserve;
    }

    public void setReserve(String reserve) {
        this.reserve = reserve;
    }

    public Date getDataTime() {
        return dataTime;
    }

    public void setDataTime(Date dataTime) {
        this.dataTime = dataTime;
    }

    public Date getAwakenInterval() {
        return awakenInterval;
    }

    public void setAwakenInterval(Date awakenInterval) {
        this.awakenInterval = awakenInterval;
    }

    public Date getDataRevTime() {
        return dataRevTime;
    }

    public void setDataRevTime(Date dataRevTime) {
        this.dataRevTime = dataRevTime;
    }

    @Override
    public String toString() {
        return "DeviceData{" +
        "deviceSn=" + deviceSn +
        ", firmwareVer=" + firmwareVer +
        ", baseStationId=" + baseStationId +
        ", csq=" + csq +
        ", pci=" + pci +
        ", iemi=" + iemi +
        ", imsi=" + imsi +
        ", deviceStatus=" + deviceStatus +
        ", deviceBatteryLevel=" + deviceBatteryLevel +
        ", positionStatus=" + positionStatus +
        ", gpsLatitude=" + gpsLatitude +
        ", gpsLongitude=" + gpsLongitude +
        ", gpsTime=" + gpsTime +
        ", gpsSpeed=" + gpsSpeed +
        ", gpsAngle=" + gpsAngle +
        ", gpsAltitude=" + gpsAltitude +
        ", messageId=" + messageId +
        ", reserve=" + reserve +
        ", dataTime=" + dataTime +
        ", awakenInterval=" + awakenInterval +
        ", dataRevTime=" + dataRevTime +
        "}";
    }
}
