package com.hgzx.plp.ds.oc.model;

import java.io.Serializable;

import com.alibaba.fastjson.JSON;

/**
 * 命令响应信息t
 * @author 柏耀明
 * statusCode: 404
 * {
    "error_code": "100418",
    "error_desc": "The deviceData is not existed. For more information, please visit the following URL: http://developer.huawei.com/ict/forum/forum.php?mod=viewthread&tid=2161&extra="
   }
 
 */
public class OcRsp implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private String responseBody;
	
	private Integer statusCode;
	
	public OcRsp() {
		
	}
	
	public OcRsp(Integer statusCode, String responseBody) {
		this.responseBody = responseBody;
		this.statusCode = statusCode;
	}
	
	public <T> T getData(Class<T> clazz) {
		return JSON.parseObject(responseBody, clazz);
	}

	public Integer getStatusCode() {
		return statusCode;
	}

	public void setStatusCode(Integer statusCode) {
		this.statusCode = statusCode;
	}
	
	public String getResponseBody() {
		return responseBody;
	}

	public void setResponseBody(String responseBody) {
		this.responseBody = responseBody;
	}

	@Override
	public String toString() {
		return "responseBody=" + responseBody + ", statusCode=" + statusCode;
	}
	
}
