package com.hgzx.plp.ds.oc.model;

import java.io.Serializable;

import com.alibaba.fastjson.JSON;

/**
 * {返回结果封装类}
 * 
 * @created 2016年7月16日
 * @lastModified
 * @history
 */
public class ResultData<T> implements Serializable {

    private static final long serialVersionUID = 1L;

    public static final String RESULT_CODE_SUCCESS = "0000";

    // 业务结果编码
    private String resultCode = RESULT_CODE_SUCCESS;

    private boolean success = true;
    
    private T result;

    // 返回消息
    private String resultMsg = "";

    public ResultData() {
        this.resultCode = RESULT_CODE_SUCCESS;
        this.resultMsg = "成功(0000)";
    }

    public ResultData(String resultCode, String resultMsg) {
        this.resultCode = resultCode;
        this.resultMsg = resultMsg;
    }
    
    public ResultData(boolean success, String resultCode, String resultMsg) {
        this.resultCode = resultCode;
        this.resultMsg = resultMsg;
        this.success = success;
    }
    
    public ResultData(boolean success, String resultCode, String resultMsg, T result) {
        this.resultCode = resultCode;
        this.resultMsg = resultMsg;
        this.success = success;
    }

    public String getResultCode() {
        return resultCode;
    }

    public void setResultCode(String resultCode) {
        this.resultCode = resultCode;
    }

    public String getResultMsg() {
        return resultMsg;
    }

    public void setResultMsg(String resultMsg) {
        this.resultMsg = resultMsg;
    }

    public T getResult() {
        return result;
    }

    public void setResult(T result) {
        this.result = result;
    }

    public String toJsonStr() {
        return JSON.toJSONString(this);
    }

    public boolean isSuccess() {
        return success;
    }

    public void setSuccess(boolean success) {
        this.success = success;
    }
}
